<template>
  <div class="app-container">
    <crud-table
      @getList="fetchCollection"
      @go="go"
      @remove="remove"
      :resourceName="resourceName"
      :rows="collection.data"
      :loading="loading"
    >
      <template slot="columns">
        <el-table-column
          prop="email" label="E-mail" :min-width="160"
        />
        <el-table-column
          prop="role" label="Rol" :min-width="160" :formatter="translateColumn"
        />
        </el-table-column>
      </template>

      <el-row :gutter="20" slot="filters">
        <el-col :span="12">
          <el-input
            v-model="query.email.$search"
            @input="debouncedFetchCollection"
            placeholder="Filtrar por E-Mail"
            clearable />
        </el-col>
        <el-col :span="12">
          <el-select
            @input="debouncedFetchCollection"
            v-model="query.role.$in"
            placeholder="Roles" multiple collapse-tags>
            <el-option
              v-for="(role, idx) in roles"
              :key="idx"
              :label="$t(role)"
              :value="role">
            </el-option>
          </el-select>
        </el-col>
      </el-row>
    </crud-table>
    <el-pagination
      background
      @current-change="paginate"
      layout="prev, pager, next"
      :page-size="collection.limit"
      :total="collection.total">
    </el-pagination>
  </div>
</template>

<script>
  import api from '@/feathers'
  import CrudTable from '@/common/crud-table.component'
  import CrudTableMixin from '@/common/crud-table.mixin'
  import { debounce } from 'lodash'
  import auth from '@/services/auth'

  export default {
    name: 'users-list',
    mixins: [CrudTableMixin],
    components: {
      CrudTable,
    },
    data() {
      return {
        resourceName: {
          singular: 'User',
          plural: 'Users'
        },
        collection: {
          data: [],
          total: 0
        },
        query: {
          email: {$search: ''},
          role: {$in: []},
          $limit: 10,
          $skip: 0
        },
        roles: [],
        loading: false,
      }
    },
    async created() {
      this.routePrefix = 'users'
      this.service = api.service('users')

      this.getRoles()
      await this.fetchCollection()
    },
    methods: {
      async debouncedFetchCollection() {
        return debounce(this.fetchCollection, 500)()
      },
      async fetchCollection() {
        this.loading = true
        const response = await this.service.find({
          query: this.query
        })
        this.collection = response
        this.loading = false
      },
      getRoles() {
        this.roles = auth.getRoles()
        this.query.role.$in = this.roles.slice()
      },
      translateColumn(row, options, value) {
        return this.$t(value)
      }
    }
  }
</script>
